#include <AFMotor.h>
#include <SoftwareSerial.h>
#include "mooseoutline.h"
#include "anonymoose.h"
#include "smilingmoose.h"

int heatTime = 80;
int heatInterval = 255;
char printDensity = 15; 
char printBreakTime = 15;
unsigned long time;
unsigned long lastRead;
int coin = 0;
int type = 0;
String sayings[7][4];
String mooseFacts[14];
int zero = 0;
int printMode = 0;
int bodyPos = 0;


#define INVERSE_MASK       (1 << 1)
#define UPDOWN_MASK        (1 << 2)
#define BOLD_MASK          (1 << 3)
#define DOUBLE_HEIGHT_MASK (1 << 4)
#define DOUBLE_WIDTH_MASK  (1 << 5)
#define STRIKE_MASK        (1 << 6)
#define rxPin 51    // Serial input (connects to Emic 2 SOUT)
#define txPin 53    // Serial output (connects to Emic 2 SIN)
#define powerPin 49
#define groundPin 47
SoftwareSerial emicSerial =  SoftwareSerial(rxPin, txPin);

#define moose-outline_width  300
#define moose-outline_height 266


// DC motor on M2
AF_DCMotor mouth(2);
AF_DCMotor body(1);

void setup() {
  randomSeed(analogRead(0));
  Serial.begin(9600);           // set up Serial library at 9600 bps
  Serial1.begin(19200); // to write to our new printer
  Serial2.begin(9600);
  randomSeed(analogRead(4));
  attachInterrupt(2, sendcoin, RISING);
  pinMode(rxPin, INPUT);
  pinMode(txPin, OUTPUT);
  pinMode(powerPin, OUTPUT);
  pinMode(groundPin, OUTPUT);
  digitalWrite(powerPin, HIGH);
  digitalWrite(groundPin, LOW);
  emicSerial.begin(9600);
  emicSerial.print('\n');             // Send a CR in case the system is already up
  while (emicSerial.read() != ':');   // When the Emic 2 has initialized and is ready, it will send a single ':' character, so wait here until we receive it
  delay(10);                          // Short delay
  emicSerial.flush();                 // Flush the receive buffer
  
  time = millis();
  
  sayings[0][0] = " Fortune 1 ";
  sayings[0][1] = "blah blah blah";
  sayings[0][2] = "blah blah blah";
  sayings[0][3] = "";
  
  sayings[1][0] = " Fortune 2 ";
  sayings[1][1] = "The blah blahs";
  sayings[1][2] = "are coming";
  sayings[1][3] = "";
  
  sayings[2][0] = " Fortune 3 ";
  sayings[2][1] = "Hi DAD"; 
  sayings[2][2] = "Here we go";
  sayings[2][3] = "";
  
  sayings[3][0] = " Fortune 4 ";
  sayings[3][1] = "Memememe";
  sayings[3][2] = "";
  sayings[3][3] = "";
  
  sayings[4][0] = " Fortune 5 ";
  sayings[4][1] = "Keep it simple";
  sayings[4][2] = "stupid!";
  sayings[4][3] = "or don't";
  
  sayings[5][0] = " Fortune 6 ";
  sayings[5][1] = "I'm going to";
  sayings[5][2] = "Disneyland";
  sayings[5][3] = "";
  
  sayings[6][0] = " Fortune 7 ";
  sayings[6][1] = "this is your fortune";
  sayings[6][2] = "";
  sayings[6][3] = "";
  
  
  mooseFacts[0] = "Moose live 15 to 25 years";
  mooseFacts[1] = "The avg. Moose weighs > 1200 lbs";
  mooseFacts[2] = "Moose are the largest animal in the deer family";
  mooseFacts[3] = "Moose are great swimmers";
  mooseFacts[4] = "Moose can run faster than 30 mph";
  mooseFacts[5] = "Moose can feed under water";
  mooseFacts[6] = "Canada may have as many as      1,000,000 moose";
  mooseFacts[7] = "Male moose are called Bull Moose";
  mooseFacts[8] = "Only Bull Moose have antlers";
  mooseFacts[9] = "Bulls' antlers can span up to 6 feet wide & weigh up to 90 lbs";
  mooseFacts[10] = "Bull Moose shed their antlers  every winter and grows them  back every spring";
  mooseFacts[11] = "Moose have 32 teeth";
  mooseFacts[12] = "Moose have bad eyesight";
  mooseFacts[13] = "Moose have no upper front teeth";
  
  initPrinter();
   
  // turn on motor #2
  mouth.setSpeed(255);
  body.setSpeed(255);
  body.run(RELEASE);
  mouth.run(RELEASE);
}

void writePrintMode()
{
   Serial.println(printMode);
   Serial1.write(27);
   Serial1.write(33);
   Serial1.write(printMode);
}

void setPrintMode(uint8_t mask) {
  printMode |= mask;
  writePrintMode();
  //charHeight = (printMode & DOUBLE_HEIGHT_MASK) ? 24 : 48;
  //maxColumn  = (printMode & DOUBLE_WIDTH_MASK ) ? 16 : 32;
}

void setNormalMode()
{
  printMode = 0;
  writePrintMode();
  Serial1.write(27); 
  Serial1.write(45);
  Serial1.write(zero);
  Serial1.write(27); 
  Serial1.write(32);
  Serial1.write(zero);
  Serial1.write(29); 
  Serial1.write(33);
  Serial1.write(zero);
}

void unsetPrintMode(uint8_t mask)
{
   printMode &= ~mask;
   writePrintMode();
}


void printerLineFeed(int lines)
{
   for(int i = 0; i < lines; i++)
   {
     Serial1.write(10);
   } 
}

void writeBytes(uint8_t a) {
  Serial1.write(a);
}

void writeBytes(uint8_t a, uint8_t b) {
  Serial1.write(a);
  Serial1.write(b);
  delay(300);
}

void writeBytes(uint8_t a, uint8_t b, uint8_t c) {
  Serial1.write(a);
  Serial1.write(b);
  Serial1.write(c);
  delay(300);
}

void writeBytes(uint8_t a, uint8_t b, uint8_t c, uint8_t d) {
  Serial1.write(a);
  Serial1.write(b);
  Serial1.write(c);
  Serial1.write(d);
  delay(300);
}

void printBitmap(Stream *stream) {
  uint8_t  tmp;
  uint16_t width, height;

  tmp    =  stream->read();
  width  = (stream->read() << 8) + tmp;

  tmp    =  stream->read();
  height = (stream->read() << 8) + tmp;

  printBitmap(width, height, stream);
}

void printBitmap(int w, int h, Stream *stream) {
  int rowBytes, rowBytesClipped, rowStart, chunkHeight, x, y, i, c;

  rowBytes        = (w + 7) / 8; // Round up to next byte boundary
  rowBytesClipped = (rowBytes >= 48) ? 48 : rowBytes; // 384 pixels max width

  for(rowStart=0; rowStart < h; rowStart += 255) {
    // Issue up to 255 rows at a time:
    chunkHeight = h - rowStart;
    if(chunkHeight > 255) chunkHeight = 255;

    writeBytes(18, 42, chunkHeight, rowBytesClipped);

    for(y=0; y < chunkHeight; y++) {
      for(x=0; x < rowBytesClipped; x++) {
        while((c = stream->read()) < 0);
        Serial1.write((uint8_t)c);
      }
      for(i = rowBytes - rowBytesClipped; i>0; i--) {
        while((c = stream->read()) < 0);
      }
    }
    //timeoutSet(chunkHeight * dotPrintTime);
  }
  //prevByte = '\n';
}


void printBitmap(
 int w, int h, const uint8_t *bitmap, bool fromProgMem) {
  int rowBytes, rowBytesClipped, rowStart, chunkHeight, x, y, i;

  rowBytes        = (w + 7) / 8; // Round up to next byte boundary
  rowBytesClipped = (rowBytes >= 48) ? 48 : rowBytes; // 384 pixels max width

  for(i=rowStart=0; rowStart < h; rowStart += 255) {
    // Issue up to 255 rows at a time:
    chunkHeight = h - rowStart;
    if(chunkHeight > 255) chunkHeight = 255;

    writeBytes(18, 42, chunkHeight, rowBytesClipped);

    for(y=0; y < chunkHeight; y++) {
      for(x=0; x < rowBytesClipped; x++, i++) {
        Serial1.write(fromProgMem ? pgm_read_byte(bitmap + i) : *(bitmap+i));
      }
      i += rowBytes - rowBytesClipped;
    }
    //timeoutSet(chunkHeight * dotPrintTime);
  }
  //prevByte = '\n';
}


void randomAscii()
{
  Serial1.write(27);
  Serial1.write(51);
  Serial1.write(1);
  //setPrintMode(INVERSE_MASK);
  Serial1.write("    _                        _  ");
  Serial1.write(10);
  Serial1.write("   / \\.\"..-.          .-..\"./ \\ ");
  Serial1.write(10);
  Serial1.write("   | || || |   .-""-.   | || || | ");
  Serial1.write(10);
  Serial1.write("   | \\/ \\/ './ _  _ \\.' \\/ \\/ | ");
  Serial1.write(10);
  Serial1.write("   \\       _  / \\/ \\  _       / ");
  Serial1.write(10);
  Serial1.write("    '----'` \\ \\0/\\0/ / `'----'  ");
  Serial1.write(10);
  Serial1.write("             \\      /           ");
  Serial1.write(10);
  Serial1.write("              )    (            ");
  Serial1.write(10);
  Serial1.write("             | _  _ |           ");
  Serial1.write(10);
  Serial1.write("             \\0)  (0/           ");
  Serial1.write(10);
  Serial1.write("              `'--'`            ");
  Serial1.write(10);
  Serial1.write(27);
  Serial1.write(50);
  //setNormalMode();
}

void mooseMove(int timeOpen) {
  
    mouth.run(BACKWARD);
    mouth.setSpeed(255);
    //body.run(FORWARD);
    //body.setSpeed(255);
    int bodyMove = random(10)*20;
    mooseBodyMove(bodyMove);
    //delay(bodyMove);
    //body.run(BACKWARD);
    //body.setSpeed(255);  
    //delay(bodyMove);
    //body.setSpeed(0);  
    delay(timeOpen-bodyMove);
    mouth.setSpeed(0);
    //mouth.run(BACKWARD);
}

void mooseBodyMove(int timeToMove){
    if(bodyPos == 1)
    {
      body.run(FORWARD);
      body.setSpeed(255);
      int bodyMove = random(10)*40;
      delay(timeToMove);
      bodyPos = 0;
    }
    else
    {
      body.run(BACKWARD);
      body.setSpeed(255);
      delay(timeToMove);
      bodyPos = 1;
    }
}

void clearEmicSerialRead()
{
  while (emicSerial.available() > 0)
  {
    Serial.println(emicSerial.read()); 
  } 
}

void singSong() {
  emicSerial.println("V0");
  delay(100);
  
  emicSerial.println("P0");
  int song = random(3);
  if (song == 0)
  {
    emicSerial.println("S[:rate 230][:n0][:dv ap 200 sm 100 ri 100][WEH<125,12>LX<75>YXOR<200,14>AH<200,17>AXRIY<300,21>LL<100>TAH<300>F<100>KUH<200,19>KIY<200,17>WIH<125>TH<75>AX<200,14>LLAO<300,17>NX<100>HXIH<200>STOR<200,14>IY<400,19>_<500> AH<125,17>V<75> BRREY<200,19>K AH<125,17>N<75>LLIH<200,19>DXEL<200,17>HXAR<300,19>TS<100>LLAY<125>K<75>DHAX<200,17>WAH<125,19>N<75> IH<125>N<75>MIY<400,21>_<400>DHAE<200>TS<100>OW<200,19>KEY<400,17>LLEH<125,14>TS<75>SIY<400,17>HXAW<200>YU<200,14>DUW<400,19>IH<125,17>T<75>_<400>PUH<125,19>T<75>AH<125>P<75>YXOR<200,17>DUW<450,19>KS<150>LLEH<300,19>TS<100>GEH<125>T<75>DAW<300>N<100>TUW<400,21>IH<200,19>T<100>HXIH<125,21>T<75>MIY<200,19>WIH<125>TH<75>YXOR<200,17>BEH<300>ST<100>SHAO<300,21>T<100>_<1100>WAY<200,17>DOW<125,19>N<75>CHAX<200,17>HXIH<70,21>T<30>MIY<100,19>WIH<125>TH<75>YXOR<200,17>BEH<300,19>ST<100>SHAO<200,14>AO<300,12>T<100>_<1200>HXIH<125,21>T<75>MIY<200,19>WIH<125>TH<75>YXOR<200,17>BEH<300>ST<100>SHAO<300,21>T<100>_<800>FAY<200>RR<200,22>AX<200,24>WEH<400,19>EY<900,17>][:n0]");
    for(int i = 0; i < 22; i++)
    {
       mooseMove(random(500,1450));
       delay(random(150,300));
    }
    clearEmicSerialRead();
  }
  else if(song == 1)
  {
    emicSerial.println("S [:phone arpa speak on][:rate 180][:n0][:dv hs 95 br 0 as 90 ap 90 sm 90 ri 100][EY<800,15>DEL<400,18>VAY<900,25>S<300>EY<800,23>DEL<400,18>VAY<900,16>S<300>EH<800,15>VRIY<400>MOR<400>NIH<250,16>NX<150>YU<400,18>GRIY<1100,20>T<100>MIY<800,18>_<400>SMAO<500,15>LX<300>AE<250,18>N<100>D<50>WAY<1100,25>T<100>KLLIY<500,23>N<300>AE<250,18>N<100>D<50>BRAY<1100,16>T<100>YU<800,15>LLUH<300,18>K<100>HXAE<400>PIY<400,20>TUW<400,22>MIY<1000,23>TMIY<900,23>_<800>BLLAO<800,25>SAH<125,18>M<75>AH<250>V<150>SNOW<400,22>MEY<400,20>YU<400,18>BLLUW<500,15>M<300>AE<250,18>N<100>D<50>GROW<900,23>_<300>BLLUW<500,20>M<300>AE<250,23>N<100>D<50>GROW<800,25>FOR<400,23>EH<1200,22>VRR<800,18>_<400>EY<800,15>DEL<400,18>VAY<900,25>S<300>EY<800,23>DEL<400,18>VAY<900,16>S<300>BLLEH<600,15>S<200>MAY<400,18>HXOW<250>M<150>LLAE<250,20>N<100>D<50>FOR<400,22>EH<1200,23>VRR<800>][:n0]"); 
    for(int i = 0; i < 40; i++)
    {
       mooseMove(random(500,1450));
       delay(random(150,300));
    }
    clearEmicSerialRead();
  }
  else //if (song == 2)
  {
     emicSerial.println("D1"); 
     for(int i = 0; i < 22; i++)
     {
       mooseMove(random(500,1450));
       delay(random(150,300));
     }
     clearEmicSerialRead();
  }
  /*else
  { 
    emicSerial.println("S [:phone arpa speak on][:rate 190][:n2][:dv ap 200 sm 100 ri 100][R EY<200,17>N<100>DRAO<200,24>PS<100>AO<200>N<100>ROW<300,19>ZIX<200,17>Z<100>AE<150>N<100>D<50>WIH<300,12>SKRR<200,17>Z<100>AO<200>N<100>KIH<300,19>TAH<150,17>N<100>Z<50>_<300>BRAY<200>T<100>KAO<300,24>PRR<300>K EH<300,19>TEL<200,17>Z<100>AE<150>N<100>D<50>War<200,12>M<100>WUH<300,17>LL EH<200>N<100>MIH<300,19>TAH<150,17>N<100>Z<50>_<300>BRAW<200>N<100>PEY<300,24>PRR<300,22>PAE<300,17>KIH<300,19>JHIX<200,15>Z<100>TAY<200>D<100>AH<200,22>P<100>WIH<200,20>TH<100>STRIH<300,13>NX<200>Z<100>_<300>DHIY<200,12>Z<100>AR<300,13>AX<300,15>FYU<300,17>AH<200,18>V<100>MAY<300,20>FEY<300,22>VRR<300,24>EH<200,22>T<100>THIH<500,16>NX<300>Z<100>][:n0]");
    emicSerial.println("S [:phone arpa speak on][:rate 190][:n2][:dv ap 200 sm 100 ri 100][KRIY<200,17> M<100> KAH<300,24> LLRR<200> D<100> POW<300,19> NIY<200,17> Z<100> AE<150> N<100> D<50> KRIH<200,12> SP<100> AE<300,17> PEL<300> STRUW<300,19> DXEL<300,17> _<300> DOR<300> BEH<150,24> LX<100> Z<50> AE<150> N<100> D<50> SLLEY<300,19> BEH<150,17> LX<100> Z<50>AE<150> N<100> D<50> SHNIH<200,12> T<100> SEL<300,17> WIH<200> TH<100> NUW<300,19> DXEL<200,17> Z<100> _<300>WAY<150,17> LL<100> D<50> GIY<200,24> S<100> DHAE<200,22> T<100> FLLAY<300,17> WIH<200,19> TH<100> DHAX<300,15> MUW<200> N<100> AO<200,22> N<100> DHER<300,20> WIH<300,13> NX<200> Z<100> _<300>DHIY<200,12> Z<100> AR<300,13> AX<300,15> FYU<300,17> AH<200,19> V<100> MAY<300,20> FEY<300,22> VRR<300,24> EH<200,22> T<100> THIH<500,16> NX<300> Z<100>][:n0]");
    emicSerial.println("S [:phone arpa speak on][:rate 190][:n2][:dv ap 200 sm 100 ri 100][GRR<150,17> LL<100> Z<50> IH<200,24> N<100> WAY<200> T<100> DRREH<300,19> SIX<200,17> Z<100> WIH<200> TH<100> BLLUW<300,12> SAE<300,17> TAH<200> N<100> SAE<300,19> SHIX<200,17> Z<100> _<300> SNOW<300> FLLEY<200,24> KS<100> DHAE<200> T<100> STEY<300,19> AO<200,17> N<100> MAY<300> NOW<200,12> Z<100> AE<150,17> N<100> D<50> AY<300> LLAE<300,19> SHIX<200,17> Z<100> _<300>SIH<200> LL<100> VRR<300,24> WAY<200,22> T<100> WIH<200,17> N<100> TRR<200,19> Z<100> DHAE<200,15> T<100> MEH<150> LL<100> T<50> IH<200,22> N<100> TUW<300,20> SPRIH<400,13> NX<200> _<300> DHIY<200,12> Z<100> AR<300,13> AX<300,15> FYU<300,17> AH<200,19> V<100> MAY<300,20> FEY<300,22> VRR<300,23> EH<200,24> T<100> THIH<400,25> NX<100> Z<100> _<200>][:n0]");
    emicSerial.println("S [:phone arpa speak on][:rate 190][:n2][:dv ap 200 sm 100 ri 100][WEH<200,24> N<100> DHAX<300> DAO<500> G<100> BAY<200,17> TS<100> _<300> WEH<200,22> N<100> DHAX<300> BIY<600> STIH<150,16> NX<100> Z<50> _<300> WEH<200,20> N<100> AY<200> M<100> FIY<600> LLIH<200,12> NX<100> SAE<1400,17> D<100> AY<300> SIH<200> M<100> PLLIY<300,19> RIY<300,17> MEH<200,19> M<100> BRR<300,17> MAY<300,19> FEY<300,20> VRR<300,22> EH<200,20> T<100> THIH<300,22> NX<200> Z<100> AE<150,20> N<100> D<50> DHEH<200,24> N<100> AY<300,25> DOW<150,24> N<100> T<70> FIY<600,25> LX<300> _<1000> SOW<900,24> BAE<2000,20> D<100>_<40>][:n0]");
    clearEmicSerialRead();
    for(int i = 0; i < 180; i++)
    {
       mooseMove(random(500,1450));
       delay(random(150,300));
    }
  }*/
  clearEmicSerialRead();
  
  emicSerial.println("P1");
  clearEmicSerialRead();
 
}

void mooseBodyStop()
{
   body.setSpeed(0);
   body.run(RELEASE);
   mouth.run(RELEASE); 
}

void initPrinter()
{
  //Modify the print speed and heat
  Serial1.write(27);
  Serial1.write(55);
  Serial1.write(7); //Default 64 dots = 8*('7'+1)
  Serial1.write(heatTime); //Default 80 or 800us
  Serial1.write(heatInterval); //Default 2 or 20us
  //Modify the print density and timeout
  Serial1.write(18);
  Serial1.write(35);
  int printSetting = (printDensity<<4) | printBreakTime;
  Serial1.write(printSetting); //Combination of printDensity and printBreakTime
  //Serial.println();
  //Serial.println("Printer ready"); 
}

void sendcoin()
{
  type += 1;
  unsigned long curTime = millis();
  if ((curTime - time) > 50)
  {
    coin = 1;
  }
  else
  {
    coin = 2;
  }
  time = curTime;
}

void mooseTalk(String phrase)
{
     emicSerial.println("P1");
     delay(100);
     clearEmicSerialRead();
     emicSerial.println("W75");
     delay(100);
     clearEmicSerialRead();
     emicSerial.println("V0");
     delay(100);
     clearEmicSerialRead();
     emicSerial.println("N0");
     delay(100);
     clearEmicSerialRead();
     emicSerial.print('S');
     //emicSerial.print("\\/\\/");
     emicSerial.println(phrase);
     Serial.println(phrase);
     
     int i = 0;
     int u = 0;
     for(int j = 0; j <  phrase.length(); j++)
     {
         if(phrase[j] == ' ')
         {
           i++; 
         }
         if(phrase[j] == '_')
         {
            u++; 
         }
     }
     
     i = i + u/2;
     i = i - i * .25;
     delay(300);
     for(int j = 0; j < i; j++)
     {
       mooseMove(random(250,450));
       delay(random(150,300));
     }
     clearEmicSerialRead();
     //while (emicSerial.available() > 0)
     //{
        //Serial.println(emicSerial.read()); 
     //}
     //while (emicSerial.read() != ':');
}


void loop() {
 if (coin != 0)
  {
     detachInterrupt(2);
     Serial1.write(27);
     Serial1.write(64);
     initPrinter();
     //emicSerial.println("V18");
     //if(coin == 2)
     //{
     //  mooseTalk("__I __ammm __moose__taarrr. You have the special coin");
     //}
     //else
     //{
       mooseTalk("__I __ammm __moose__taarrr. Your fortune is, __BE WEAR");
       //emicSerial.println("D1");
     //}
     
     delay(300);
     
     int i = random(7);
     
     //while (emicSerial.read() != ':');
     //digitalWrite(ledPin, HIGH);         // Turn on LED while Emic is outputting audio
     mooseTalk(sayings[i][0]);
     //emicSerial.read();
     //Serial1.print(" ");
     setNormalMode();
     //emicSerial.read();
     int whichMoose = random(4);
     if(whichMoose == 1)
     {
       randomAscii();
     }
     else if(whichMoose == 2)
     {
       printBitmap(moose_outline_width, moose_outline_height, moose_outline_data, true);
     }
     else if(whichMoose == 3)
     {
       printBitmap(anonymoose_width, anonymoose_height, anonymoose_data, true);
     }
     else //0
     {
       printBitmap(smilingmoose_width, smilingmoose_height, smilingmoose_data, true);       
     }
     
     //emicSerial.println("D1");
     
     Serial1.write(27); 
     Serial1.write(45);
     Serial1.write(2);
     
     
     Serial1.print(" Moosetar Says: BEWARE!");
     delay(300);
     //setNormalMode();
     Serial1.write(10); //Sends the LF
     
     //setPrintMode(DOUBLE_HEIGHT_MASK);
     //Serial1.write(27); 
     //Serial1.write(32);
     //Serial1.write(1);
     //Serial1.write(27); 
     //Serial1.write(45);
     //Serial1.write(zero);
     setPrintMode(INVERSE_MASK);
     //setPrintMode(BOLD_MASK);
     //writePrintMode();
     //Serial1.print(" Assmume You're Owned");
     Serial1.print(sayings[i][0]);
     Serial.println(sayings[i][0]);
     setNormalMode();
     Serial1.write(10);
     Serial1.write(27); 
     Serial1.write(45);
     Serial1.write(zero);
     Serial1.print(sayings[i][1]);
     Serial.println(sayings[i][1]);
     mooseBodyMove(500);
     Serial1.write(10);
     if (sayings[i][2] != "")
     {
       Serial1.print(sayings[i][2]);
       Serial.println(sayings[i][2]);
       delay(100);
       Serial1.write(10);
     }
     if (sayings[i][3] != "")
     {
       Serial1.print(sayings[i][3]);
       Serial.println(sayings[i][3]);
       delay(100);
       Serial1.write(10);
     }
     Serial1.write(10);
     mooseBodyMove(500);
     //Serial1.write(10);
     Serial1.write("Moose Fun Fact:");
     Serial1.write(10);
     Serial1.print(mooseFacts[random(15)]);
     Serial1.write(10);
     Serial1.write(10);
  
     
     mooseBodyMove(500);
     printerLineFeed(4);

     Serial1.write(10);
     Serial1.write(10);
     
     delay(500);
     singSong();
     mooseBodyStop();
     coin = 0;
     attachInterrupt(2, sendcoin, RISING);
  } 
}
